/*
The "Redirect" class makes c++callbacks visible to ruby.
The Rubyembed Project
$Id: redirect.h,v 1.6 2003/04/17 02:41:37 neoneye Exp $

purpose:
make c++ callbacks available to ruby.

issues:
*	There is a reason why this file is not contained within 
	a namespace. This is because we wanna be easy with SWIG.
	I dont know if this is actual a problem, but im just assuming.
*/
#ifndef EMBEDRUBY_REDIRECT_H
#define EMBEDRUBY_REDIRECT_H

#include "library.h"

/*
purpose:
make c++ callbacks available to ruby

functions:
*	repaint()  invokes the virtual function view->repaint().

constraints:
*	This object is managed from ruby, thus dont raise
	c++ exceptions. Instead raise ruby exceptions.

issues:
*	ruby-wrapper, the global_view is ugly. But unfortunatly 
	I do not know any other ways to initialize this struct!
*/
class Redirect {
private:
	EMBEDRUBY::View *view;
	static EMBEDRUBY::View *global_view;
public:
	Redirect();
	~Redirect();
	void repaint();

	// bootstrapping 
	static void SetView(EMBEDRUBY::View *parent);
	static void RubyInit();
};

#endif // EMBEDRUBY_REDIRECT_H
